"use strict";
// Resolver/Mutation Wrapper
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WrapApolloResolvers = exports.ApolloCallbackWrapper = void 0;
var graphql_parse_resolve_info_1 = require("graphql-parse-resolve-info");
function ApolloCallbackWrapper(cb, resolvers, resolverType) {
    return function (parent, args, context, info) {
        var self = __assign({ parent: parent, args: args, context: context, info: info, 
            // @ts-ignore
            resolvers: resolvers[resolverType], resolverType: resolverType }, (info ? (0, graphql_parse_resolve_info_1.parseResolveInfo)(info) : {}));
        if (context && info) {
            return cb.call(self, args);
        }
        return cb.call(self, parent, args, context, info);
    };
}
exports.ApolloCallbackWrapper = ApolloCallbackWrapper;
function WrapApolloResolvers(resolvers) {
    var _loop_1 = function (resolverType) {
        var resolvers_ = resolvers[resolverType];
        if (Object.keys(resolvers_).length == 0) {
            delete resolvers[resolverType];
        }
        else {
            resolvers[resolverType] = Object.fromEntries(Object.entries(resolvers_).map(function (_a) {
                var key = _a[0], value = _a[1];
                return [key, ApolloCallbackWrapper(value, resolvers, resolverType)];
            }));
        }
    };
    for (var resolverType in resolvers) {
        _loop_1(resolverType);
    }
    return resolvers;
}
exports.WrapApolloResolvers = WrapApolloResolvers;
