"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApolloResolverWrapper = exports.WrapApolloResolvers = exports.ApolloCallbackWrapper = exports.ApolloCallbackMiddleware = void 0;
var graphql_parse_resolve_info_1 = require("graphql-parse-resolve-info");
var middleware = [];
function ApolloCallbackMiddleware(cb) {
    middleware.push(cb);
}
exports.ApolloCallbackMiddleware = ApolloCallbackMiddleware;
function ApolloCallbackWrapper(cb, resolvers, resolverType) {
    return function (parent, args, context, info) {
        return __awaiter(this, void 0, void 0, function () {
            var resolving, res, _i, middleware_1, func;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resolving = __assign({ parent: parent, args: args, 
                            // @ts-ignore
                            context: context, 
                            // @ts-ignore
                            info: info, resolvers: resolvers[resolverType], resolverType: resolverType }, (info ? (0, graphql_parse_resolve_info_1.parseResolveInfo)(info) : {}));
                        if (!(context && info)) return [3 /*break*/, 5];
                        res = cb(args, context, resolving);
                        _i = 0, middleware_1 = middleware;
                        _a.label = 1;
                    case 1:
                        if (!(_i < middleware_1.length)) return [3 /*break*/, 4];
                        func = middleware_1[_i];
                        return [4 /*yield*/, func(res, args, context, resolving)];
                    case 2:
                        res = (_a.sent()) || res;
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, res];
                    case 5: return [2 /*return*/, cb(parent, args, context, info)];
                }
            });
        });
    };
}
exports.ApolloCallbackWrapper = ApolloCallbackWrapper;
function WrapApolloResolvers(resolvers) {
    var _loop_1 = function (resolverType) {
        var resolvers_ = resolvers[resolverType];
        if (Object.keys(resolvers_).length == 0) {
            delete resolvers[resolverType];
        }
        else {
            resolvers[resolverType] = Object.fromEntries(Object.entries(resolvers_).map(function (_a) {
                var key = _a[0], value = _a[1];
                return [key, ApolloCallbackWrapper(value, resolvers, resolverType)];
            }));
        }
    };
    for (var resolverType in resolvers) {
        _loop_1(resolverType);
    }
    return resolvers;
}
exports.WrapApolloResolvers = WrapApolloResolvers;
//** Used in delayed computation of wrapped callbacks */
/*
class mutations extends ApolloResolverWrapper {
    static collection = {
        rename
    };
}; new mutations();

mutations.collection; // { rename: wrapped(rename) }
*/
var ApolloResolverWrapper = /** @class */ (function () {
    function ApolloResolverWrapper(resolverType) {
        var groups = Object.getPrototypeOf(this).constructor;
        if (!resolverType) {
            var name_1 = groups.name.toLowerCase();
            if (name_1.includes('mut')) {
                resolverType = 'Mutation';
            }
            else if (name_1.includes('que')) {
                resolverType = 'Query';
            }
            else if (name_1.includes('sub')) {
                resolverType = 'Subscription';
            }
            else {
                resolverType = '';
            }
        }
        var _loop_2 = function (key) {
            var resolvers = groups[key];
            var wrappedKey = '_' + key;
            Object.defineProperty(groups, key, {
                get: function () {
                    if (wrappedKey in this)
                        return this[wrappedKey];
                    var _resolvers = __assign({}, resolvers);
                    for (var name_2 in resolvers) {
                        _resolvers[name_2] = ApolloCallbackWrapper(resolvers[name_2], _resolvers, resolverType);
                    }
                    this[wrappedKey] = _resolvers;
                    return this[key];
                }
            });
        };
        for (var key in groups) {
            _loop_2(key);
        }
    }
    return ApolloResolverWrapper;
}());
exports.ApolloResolverWrapper = ApolloResolverWrapper;
